/*******************************************************************************
 * Stefan Meyer, 2012 Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 ******************************************************************************/
package org.atemsource.atem.utility.transform.api;

import org.atemsource.atem.api.type.EntityType;
import org.atemsource.atem.api.type.EntityTypeBuilder;

public interface AttributeTransformationBuilder<A, B, T extends AttributeTransformationBuilder<A,B,T>> {

	T from(String attributePath);

	A fromMethod();

	T metaValue(String name, Object metaData);

	void build(EntityTypeBuilder targetTypeBuilder);

	AttributeTransformation<A,B> create(EntityType<B> targetType);

}
